unit Utils;

interface
uses Windows,ComCtrls,Registry,
     Forms,Controls,Grids,Math,Classes;
const
  FormulaADeliveriesRegPath = '\Software\AAA\Formula A\Deliveries';
  FormulaADeliveriesMainFile = 'main_subjects.txt';
  FormulaADeliveriesMarginsFile = 'margins.txt';
  FormulaADeliveriesReportFile = 'report.doc';
var
  MainPath:string='';

function RusUpperCase (const S:string):string;
function RusLowerCase (const S:string):string;
function RusUpperChar (const Ch:char):char;
function RusIsEqualent (const S1,S2:string):boolean;
function RusFormatAsName (const S:string):string;

function EncodeStr (const S:string):string;
function DecodeStr (const S:string):string;


implementation
uses SysUtils, FileCtrl;

function RusUpperCase (const S:string):string;
var
  Ch: Char;
  i: Integer;
begin
  SetLength(Result, Length(S));
  for i:=1 to Length(S) do
  begin
    Ch := S[i];
    if (Ch >= '') and (Ch <= '') then Dec(Ch, 32);
    if Ch='' then Ch:='';
    if (Ch >= 'a') and (Ch <= 'z') then Dec(Ch, 32);
    result[i]:=Ch;
  end;
end;

function RusLowerCase (const S:string):string;
var
  Ch: Char;
  i: Integer;
begin
  SetLength(Result, Length(S));
  for i:=1 to Length(S) do
  begin
    Ch := S[i];
    if (Ch >= '') and (Ch <= '') then Inc(Ch, 32);
    if Ch='' then Ch:='';
    if (Ch >= 'A') and (Ch <= 'Z') then Inc(Ch, 32);
    result[i]:=Ch;
  end;
end;

function RusUpperChar (const Ch:char):char;
begin
  result:=Ch;
  if (result >= '') and (result <= '') then Dec(result, 32);
  if result='' then result:='';
  if (result >= 'a') and (result <= 'z') then Dec(result, 32);
end;

function RusIsEqualent (const S1,S2:string):boolean;
begin
  result:=RusUpperCase(S1)=RusUpperCase(S2);
end;

function RusFormatAsName (const S:string):string;
begin
result:='';
  if Length(S)>0 then
  begin
    result:=RusLowerCase(S);
    result[1]:=RusUpperChar(result[1]);
  end;
end;

function RusFindSiblingText (Node:TTreeNode;const S:string):TTreeNode;
begin
result:=Node;
  while result<>Nil do
    if RusIsEqualent(result.Text,S) then
      exit else
      result:=result.getNextSibling;

end;

function RusFindChildText (Node:TTreeNode;const S:string):TTreeNode;
begin
result:=Node.getFirstChild;
  while result<>Nil do
    if RusIsEqualent(result.Text,S) then
      exit else
      result:=result.getNextSibling;

end;

function EncodeStr (const S:string):string;
var i:Integer;
    Ch:byte;
begin
  SetLength(Result, Length(S));
  for i:=1 to Length(S) do
  begin
    Ch:=(Byte(S[i]) xor $10) + 10;
    result[i]:=Char(Ch);;
  end;
end;

function DecodeStr (const S:string):string;
var i:Integer;
    Ch:byte;
begin
  SetLength(Result, Length(S));
  for i:=1 to Length(S) do
  begin
    Ch:=(Byte(S[i]) - 10) xor $10;
    result[i]:=Char(Ch);
  end;
end;

end.
